// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#ifndef FENNEC_TEST_LANG_FUNCTION_H
#define FENNEC_TEST_LANG_FUNCTION_H

#include "../../test.h"

#include <fennec/lang/function.h>

namespace fennec::test
{

inline bool fennec_test_lang_function_test() {
	return true;
}

inline void fennec_test_lang_function() {
	function<bool()> test;

	fennec_test_run(bool(test = fennec_test_lang_function_test), true);
	fennec_test_run(test(), true);

	fennec_test_spacer(1);

	fennec_test_run(bool(test = []() { return true; }), true);
	fennec_test_run(test(), true);

	fennec_test_spacer(1);

	fennec_test_run(bool(test = nullptr), false);
}

}

#endif // FENNEC_TEST_LANG_FUNCTION_H